<?php

/**
 * PluginManagedFileTable
 * 
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class PluginManagedFileTable extends opAccessControlDoctrineTable
{
  /**
   * Returns an instance of this class.
   *
   * @return object PluginManagedFileTable
   */
  public static function getInstance()
  {
    return Doctrine_Core::getTable('PluginManagedFile');
  }

  public function getDirectoryFileList($directoryId)
  {
    return ManagedFileQuery::getOrderedQuery()->addDirectoryId($directoryId);
  }

  public function getMemberFileList($memberId)
  {
    $allowedTypes = array('public');
    if ($memberId === sfContext::getInstance()->getUser()->getMemberId())
    {
      $allowedTypes[] = 'private';
    }

    return ManagedFileQuery::getFileListQuery($allowedTypes)
      ->andWhere('d.member_id = ?', $memberId);
  }

  /**
   * @param community_id
   * @return Doctrine_Query コミュニティで共有しているファイル一覧を取得するクエリ
   */
  public function getCommunityFileList($communityId)
  {
    $directoryIds = Doctrine::getTable('DirectoryConfig')->getDirectoryIdsByCommunityId($communityId);

    return ManagedFileQuery::getOrderedQuery()->addDirectoryId($directoryIds);
  }

  public function getPublicFileList($searchParameter = null)
  {
    $q = ManagedFileQuery::getFileListQuery(array('public'));

    if ($searchParameter)
    {
      $q->addSearchQuery($searchParameter);
    }

    return $q;
  }

  public function appendRoles(Zend_Acl $acl)
  {
    return $acl
      ->addRole(new Zend_Acl_Role('reject'))
      ->addRole(new Zend_Acl_Role('everyone'))
      ->addRole(new Zend_Acl_Role('member'), 'everyone')
      ->addRole(new Zend_Acl_Role('author'), 'member')
      ->addRole(new Zend_Acl_Role('admin'), 'author');
  }

  public function appendRules(Zend_Acl $acl, $resource = null)
  {
    $directory = $resource ? $resource->FileDirectory : null;
    if (!$directory)
    {
      throw new LogicException('ManagedFileTable::appendRules resource is null.');
    }

    # all community member can view file
    $acl->allow('member', $resource, 'view');
    $acl->allow('author', $resource, 'edit');
    $acl->allow('author', $resource, 'delete');

    if ($directory->isPublic())
    {
      $acl->allow('everyone', $resource, 'view');
    }
    elseif ($directory->isCommunity())
    {
      if ('public' === $directory->getConfig()->getCommunityConfig('file_public_flag'))
      {
        $acl->allow('everyone', $resource, 'view');
      }
    }

    return $acl;
  }
}
